/********************************************************************
 *
 * Beispiel-Programm zum Verfolgen von XKey-Events
 *
 * Quelle: BREDEX GmbH, Braunschweig
 *
 ********************************************************************/

/* Header-Dateien */
#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

main (argc, argv)
int argc;
char** argv;
{
    Display* display;           /* Display */
    Window window;              /* ueberwachtes Fenster */
    XEvent event;               /* X-Event */
    char   buffer[10];          /* Buffer fuer eingegebene Zeichen */
    int    count;               /* Anzahl eingegebener Zeichen */

    /* Display oeffnen (Verbindung zum X-Server herstellen) */
    display = XOpenDisplay ((char*)NULL);
    if (display == NULL) {
        fprintf (stderr, "can't open \"%s\"\n", XDisplayName((char*)NULL));
        exit (1);
    }

    /* Event-Maske fuer ubergebenes Fenster setzen
     * (Default-Fenster: Root-Window)
     */
    if (argc < 2) {
        printf ("ueberwache Key-Events vom Root-Window\n");
        window = RootWindow (display, DefaultScreen (display));
    }
    else {
        window = atoi (argv[1]);
        printf ("ueberwache Key-Events von Window mit ID %d\n", window);
    }
    XSelectInput (display, window, KeyPressMask | KeyReleaseMask);

    /* Ereignis-Schleife
     */
    for (;;) {
        /* Event lesen */
        XNextEvent (display, &event);

        /* ... und verarbeiten */
        switch (event.type) {
          case KeyPress:
          case KeyRelease:
            count = XLookupString (&event, buffer, sizeof(buffer),
                                   (KeySym*)NULL, (XComposeStatus*)NULL);
            buffer[count] = '\0';
            printf ("%s: %s\n", event.type == KeyPress ?
                                   "KeyPress" : "KeyRelease", buffer);
            break;
        }
    }
}

